<?php
/* Adding main view of plugin */
if ( !defined( 'ABSPATH' ) ) {
    die;
}
/*
 * Declaring Class
 */
class AWCA_Admin_View extends AWCA_View {
  /* adding tabs array */
  private $awca_config_status = array();

  public function on_load(){
    $this->tabs = array(
       'auth'   => 'Authentication',
    );
    if($auth_settings = get_option('awca_auth_settings')){
      if ( awca_fs()->is_not_paying() && !(awca_fs()->is_trial()) || (!awca_fs()->is_premium())) {
        $this->tabs = array(
           'track' => 'Tracking Settings',
           'event' => 'Event Tracking',
           'advance' => 'Advance Integrations',
        );
        if(isset($auth_settings['property_id']) && (strpos($auth_settings['property_id'],'UA') !== false)){
          $this->tabs = array_merge( $this->tabs,array('report'=>'Find Reports'));
          $this->tabs = array_merge(array('dash'=>'Dashboard'),$this->tabs );
        }elseif(isset($auth_settings['tracking_id']) && (strpos($auth_settings['tracking_id'],'UA') !== false)){
          $this->tabs = array_merge( $this->tabs,array('report'=>'Find Reports'));
        }elseif(isset($auth_settings['property_id']) && (strpos($auth_settings['property_id'],'G') !== false)){
          $this->tabs = array_merge(array('dash'=>'Dashboard'),$this->tabs );
        }
        $this->tabs = array_merge( $this->tabs,array('upgrade' => 'Upgrade to Pro'));
        $this->tabs = array_merge($this->tabs,array('unlink' => 'Un-Link Google Analytics'));
      }else{
        $this->tabs = array(
           'track' => 'Tracking Settings',
           'event' => 'Event Tracking',
           'advance__premium_only' => 'Advance Integrations',
           'support__premium_only' => 'Support',
        );
        if(isset($auth_settings['property_id']) && (strpos($auth_settings['property_id'],'UA') !== false)){
          $this->tabs = array_merge( $this->tabs,array('report__premium_only'=>'Find Reports'));
          $this->tabs = array_merge(array('dash__premium_only'=>'Dashboard'),$this->tabs );
        }elseif(isset($auth_settings['tracking_id']) && (strpos($auth_settings['tracking_id'],'UA') !== false)){
          $this->tabs = array_merge( $this->tabs,array('report__premium_only'=>'Find Reports'));
        }elseif(isset($auth_settings['property_id']) && (strpos($auth_settings['property_id'],'G') !== false)){
          $this->tabs = array_merge(array('dash__premium_only'=>'Dashboard'),$this->tabs );
        }
        $this->tabs = array_merge($this->tabs,array('unlink' => 'Un-Link Google Analytics'));
      }
    }
    $awca_config_status = AWCA_Auth::get_instance()->get_awca_config_status();
    if(is_array($awca_config_status)){
      $this->awca_config_status =  $awca_config_status;
    }
  }

  /* Adding & Removing notice to admin section */
  public function adding_notice(){
    if(isset($_POST['awca_block_admin_notice'])){
      unset( $_POST['awca_block_admin_notice']);
      update_option('awca_block_admin_notice',true);
    }
    if($awca_error_count = get_option('awca_error_count')) {
      if( ($awca_error_count > 0) && (!get_option('awca_block_admin_notice'))){
        echo '<div class="notice notice-warning is-dismissible">
           <div style="display:block;margin:.5em;">
            <p style="display:inline">There are some configuration issues need to address for <b>Woocommerce Analytics</b> Plugin to work seemlessly. <a href="'.AWCA_SITE_URL.'/wp-admin/admin.php?page=awca_pro_plugin_options&view=status">Click Here</a> to address those.</p><form method="post" style="display:inline;"><button type="submit" value="yes" name="awca_block_admin_notice" style="display:inline;background: transparent;border:none;color:#0073aa" class="">Hide this notice!</button></form>
        </div></div>';
      }
    }
  }

 /* rendering tabs for plugin settings */
 public function render(){
 ?>
   <div class="row">
    <div class="col s12 m12 l3 xl3">
      <div class="content-pad">
        <img class="responsive-img small-plugin-image" src="<?php echo AWCA_URL . 'assests/images/WoocommerceAnalytics.png'; ?>">
      </div>
       <ul class="collection menu-collection">
         <?php
         if ( awca_fs()->is_not_paying() && !awca_fs()->is_trial() ) {
             ?>
             <a class="collection-item upgrade-btn" style="background-color:#26A69A !important;color:#ffffff !important" href="<?php echo  awca_fs()->get_trial_url() ;?>">
               <li><span style="color:#ffffff !important">Get Free Trial of Pro Version!</span>
                 <i class="material-icons right">check_circle</i>
               </li>
             </a>
        <?php }
         foreach ( $this->get_tabs() as $tab => $name ) {
           if($tab != 'unlink'){ ?>
        		 <a href="<?php echo  esc_url( $this->get_tab_url( $tab ) ); ?>" class="collection-item <?php echo  ( $tab === $this->get_current_tab() ? 'white z-depth-1' : null ) ;?>">
        			 <li><span><?php echo  esc_html( $name );?></span>
                 <?php if($name == 'Integration Status'){
                   if(isset($this->awca_config_status['error_count']) && $this->awca_config_status['error_count'] > 0){
                     echo '<span class="new badge white-text awca-badge" data-badge-caption="">'.$this->awca_config_status['error_count'].'</span>';
                    }else{
                      if(isset($this->awca_config_status['error_count']) && $this->awca_config_status['error_count'] == 0){
                         echo '<i class="material-icons right">check_circle</i>';
                       }else{
                         echo '<i class="material-icons right info">info</i>';
                       }
                    }
                  } elseif ($name == 'Authentication') {
                    if(get_option('awca_auth_settings')){
                      echo '<i class="material-icons right">check_circle</i>';
                     }else{
                       echo '<i class="material-icons right info">info</i>';
                     }
                  }elseif ($name == 'Advance Integrations') {
                    if ( awca_fs()->is_not_paying() && !(awca_fs()->is_trial()) || (!awca_fs()->is_premium())) {
                      echo '<i class="material-icons right info">info</i>';
                    }else{
                      echo '<i class="material-icons right">check_circle</i>';
                    }
                  } elseif ($name == 'Find Reports') {
                    if ( awca_fs()->is_not_paying() && !(awca_fs()->is_trial()) || (!awca_fs()->is_premium())) {
                      echo '<i class="material-icons right info">info</i>';
                    }else{
                      echo '<i class="material-icons right">check_circle</i>';
                    }
                  }elseif ($name == 'Upgrade to Pro') {
                    echo '<i class="material-icons right shopping_cart">shopping_cart</i>';
                  } else {
                 echo '<i class="material-icons right">check_circle</i>';
                 }  ?>
               </li>
        		 </a>
           <?php }elseif($tab == 'unlink'){ ?>
             <a href="#modal1" class="collection-item modal-trigger <?php echo  ( $tab === $this->get_current_tab() ? 'white z-depth-1' : null ) ;?>">
               <li><span><?php echo  esc_html( $name );?></span>
                 <i class="material-icons right red-text">error</i>
               </li>
             </a>
           <?php }}
       ?>
      </ul>
      <div id="modal1" class="modal">
        <div class="modal-content">
          <h5>Un-Link Google Analysis from website</h5>
          <p>Are you sure you wish to un-link Google Analysis from Website?</p>
        </div>
        <div class="modal-footer">
          <a class="modal-close waves-effect waves-light btn AWCA-un-link">Un-Link Google Analytics</a>
          <a class="modal-close waves-effect waves-green btn AWCA-access-revoke">Un-Link and Remove All Settings</a>
          <a class="modal-close waves-effect waves-green btn">Cancel</a>
        </div>
      </div>
    </div>
		 <div class="content-pad">
	     <div class="col s12 m12 l9 xl9 white main-content">
         <?php if($G_id = $this->get_tracking_id() ){ ?>
         <span class="badge blue white-text right"><?php echo $G_id; ?></span>
       <?php }
       $current_tab = $this->get_current_tab();
       $expires_headers = $this->view_options( $current_tab );
       $this->view( $current_tab, $expires_headers );
       ?>
		   </div>
		</div>
  <?php
 }
 /* getting tracking id */
 public function get_tracking_id() {
   if(get_option('awca_auth_settings')){
     $auth_settings = get_option('awca_auth_settings');
     if(isset($auth_settings['property_id'])){
       $property = $auth_settings['property_id'] ;
       $pieces = explode( '|', $property );
       return $pieces[1];
     }else{
       if( isset($auth_settings['tracking_id']) ){
         return $auth_settings['tracking_id'];
       }else{
         return false;
       }
     }
   }else{
     return false;
   }
 }
 /* suppling setting and some required values */
 private function view_options( $tab ){
     $awca_settings = AWCA_Settings::get_instance();
     $awca_auth = AWCA_Auth::get_instance();
     switch ( $tab ) {
       case 'dash':
         return array (
          'defaults' => $awca_settings->init_awca_dash_defaults(),
          'property_views' => $awca_auth->get_analytics_property_views(),
          );
        case 'dash__premium_only':
          return array (
           'defaults' => $awca_settings->init_awca_dash_defaults(),
           'property_views' => $awca_auth->get_analytics_property_views(),
           );
       case 'advance':
          return array ();
        case 'advance__premium_only':
           return array (
            'defaults' => $awca_settings->init_awca_advance_defaults(),
            );
        case 'auth':
           return array (
             /* 'analytics_properties' => $awca_auth->get_analytics_properties(), */
             'analytics_g4_properties' => $awca_auth->get_analytics_g4_properties(),
             'defaults' => $awca_settings->init_awca_auth_defaults(),
            );
        case 'track':
          return array (
           'defaults' => $awca_settings->init_awca_track_defaults(),
           );
        case 'event':
          return array (
            'defaults' => $awca_settings->init_awca_events_defaults(),
          );
        case 'status':
          return array (
            'awca_config_status' => $this->awca_config_status,
          );
        case 'support__premium_only':
          return array();
        case 'report':
           return array ();
        case 'report__premium_only':
          return array (
           'defaults' => $awca_settings->init_awca_reports_list(),
           'property_views' => $awca_auth->get_analytics_property_views(),
           'account_id' => $awca_auth->get_ga_account_id(),
           );
        default:
          return array();
     }
  }
}
