<?php
/* controlling view of Authentication settings*/
if ( !defined( 'ABSPATH' ) ) {
    die;
}
/* intiating variables */
$errors = '';
$manual_tracking = false;

/* getting settings values*/
if (!get_option('awca_auth_settings')){
	$awca_auth_settings = $defaults;
}else{
	$awca_auth_settings = get_option('awca_auth_settings');
}

/* storing Authentication settings */
if (isset($_POST['awca_auth_submit'])){
  $awca_auth_settings_save = AWCA_Settings::get_instance()->parse_awca_auth_settings($_POST['awca_auth_settings']);
  if (isset($awca_auth_settings_save['agreement'])) {
    if(!empty($awca_auth_settings_save['property_id'])|| !empty($awca_auth_settings_save['tracking_id'])) {
      if(isset($awca_auth_settings_save['property_id'])){
        if(strpos((string)$awca_auth_settings_save['property_id'],'G') !== false){
            unset($awca_auth_settings_save['tracking_id']);
            unset($awca_auth_settings_save['manual_tracking']);
            update_option('awca_auth_settings',$awca_auth_settings_save);
            echo "<script>
                jQuery(document).ready(function(){
                   M.toast({html: 'Setting Saved!', classes: 'rounded teal', displayLength:4000});
                   setTimeout(function(){window.location.reload(1);}, 1000);
                });
            </script>";
            $awca_auth_settings = $awca_auth_settings_save;
        }else{
          if($awca_auth_settings_save){
            unset($awca_auth_settings_save['tracking_id']);
            unset($awca_auth_settings_save['manual_tracking']);
            update_option('awca_auth_settings',$awca_auth_settings_save);
            echo "<script>
                jQuery(document).ready(function(){
                   M.toast({html: 'Setting Saved!', classes: 'rounded teal', displayLength:4000});
                   setTimeout(function(){window.location.reload(1);}, 1000);
                });
            </script>";
            $awca_auth_settings = $awca_auth_settings_save;
          }else {
            $errors .= 'Please complete Google Analytics Website Linking Process!<br>';
            $awca_auth_settings = $awca_auth_settings_save;
          }
        }
      }else{
        $manual_tracking = true;
        if(isset($awca_auth_settings_save['manual_tracking'])){
          update_option('awca_auth_settings',$awca_auth_settings_save);
          echo "<script>
              jQuery(document).ready(function(){
                  M.toast({html: 'Setting Saved!', classes: 'rounded teal', displayLength:4000});
                  setTimeout(function(){window.location.reload(1);}, 1000);
              });
          </script>";
          $awca_auth_settings = $awca_auth_settings_save;
        }else{
          $errors .= 'Please confirm using manual tracking or use auto connect facility.<br>';
          if(get_option('awca_auth_settings')){
            delete_option('awca_auth_settings');
            $awca_auth_settings = $awca_auth_settings_save;
          }
          $awca_auth_settings = $awca_auth_settings_save;
        }
    }
  }else {
      $errors .= 'Please complete Google Analytics Website Linking Process!<br>';
      if(get_option('awca_auth_settings')){
        delete_option('awca_auth_settings');
        $awca_auth_settings = $awca_auth_settings_save;
        header("Refresh:0");
      }
      $awca_auth_settings = $awca_auth_settings_save;
    }
  }else {
      $errors .= 'Please agree with privacy policy and terms of service of plugin!<br>';
      $awca_auth_settings = $awca_auth_settings_save;
  }
}
else{
  if((($awca_auth_settings['tracking_id']??false) || ($awca_auth_settings['manual_tracking']??false)) && empty($awca_auth_settings['property_id'])){
    $manual_tracking = true;
  }
  if(!empty($analytics_ga4_properties)){
    $manual_tracking = false;
  }
}
/* display error messages */
if (strlen($errors)> 0){
    echo "<script>
            jQuery(document).ready(function(){
               M.toast({html: 'Please correct following Errors:', classes: 'rounded red', displayLength:6000});
               M.toast({html: '".$errors."', classes: 'rounded red', displayLength:8000});
            });
        </script>";
}
/* creating Authentication forms */
?>
<div class="col s12 awca-options">
  <form action="" method="POST">
		<div class="col s12 top-mar">
      <div class="col m6 s12">
        <?php
        if(get_option('awca_auth_settings')){?>
          <h5 class="left zero-mar">Authentication<span class="new badge green" data-badge-caption="completed"></span></h5>
        <?php }else{ ?>
           <h5 class="left zero-mar">Authentication<span class="new badge red" data-badge-caption="uncomplete"></span></h5>
         <?php }
         ?>
      </div>
      <div class="col m6 s12">
        <?php if ( awca_fs()->is_not_paying() && !(awca_fs()->is_trial())) { ?>
          <a class="waves-effect waves-light btn right upgrade-btn" style="margin-left:15px" href="<?php echo  awca_fs()->get_upgrade_url(); ?>">Upgrade to Pro!</a>
        <?php } ?>
        <a class="waves-effect waves-light btn right" href="https://advancedwcanalytics.com/documentation" target="_blank"><i class="material-icons left">book</i>Documentation</a>
      </div>
		</div>
		<div class="clearfix"></div>
		<div class="divider top-mar"></div>
    <div class="progress">
      <div class="indeterminate"></div>
    </div>
    <div class="row">
      <div class="col s12 center-align">
        <?php if(!isset($awca_auth_settings['tracking_id']) || empty($awca_auth_settings['tracking_id'])){
          $class_box = '';
        }else{
          $class_box ='off';
        }?>
        <p class="top-mar-30 <?php echo $class_box;?>">
          <div class="switch">
            <label>
              <b>Auto Connect Method(Recommended)</b>
              <input <?php if(!($awca_auth_settings['property_id']??false) && get_option('awca_access_token')){ echo 'disabled';} ?> id="awca_auth_settings[manual_tracking]" class="check_manual" name="awca_auth_settings[manual_tracking]" value="yes" type="checkbox" <?php checked(isset($awca_auth_settings['manual_tracking']) && $awca_auth_settings['manual_tracking']); ?> >
              <span class="lever"></span>
              <b>Manual Connect Method</b>
            </label>
          </div>
        </p>
      </div>
      <?php //$selector = ((!empty($analytics_properties) && is_array($analytics_properties))||(!empty($analytics_g4_properties) && is_array($analytics_g4_properties))); ?>
      <?php $selector = (!empty($analytics_g4_properties) && is_array($analytics_g4_properties)); ?>
 
	  <div id="auto" class="col s12">
        <?php if(!($awca_auth_settings['property_id']??false) && get_option('awca_access_token')){ //&& !get_option('awca_auth_settings')){?>
          <div class="notice notice-info top-mar">
            <p> Please choose your property which you want to link with website and hit submit button. </p>
          </div>
        <?php }elseif(!get_option('awca_access_token')){?>
          <div class="input-field col s12 center-align auto-connect">
            <div class="notice notice-info top-mar">
              <p> Please start auto-linking process by clicking below button. </p>
            </div>
          </div>
          <div class="row auto-connect">
            <div class="input-field col s12 center-align">
                <a style="text-transform: capitalize;font-weight:600" class="waves-effect waves-light white black-text btn AWCA-authenticate top-mar-30"><img width="20px" class="material-icons left" style="margin-top:7px; margin-right:10px" alt="Google sign-in" src="<?php echo AWCA_URL . 'assests/images/Google_Fevicon.png'; ?>" /><?php echo $selector? 'Re-Link with your Google account' : 'Link your Google Analytics' ; ?></a>
                <span class="helper-text top-mar-10" data-error="wrong" data-success="right">Please link your Google Analyitcs Account for data collection.</span>
            </div>
          </div>
          <div class="input-field col s12 center-align">
            <?php if(!($awca_auth_settings['property_id']??false) && !($awca_auth_settings['tracking_id']??false) && !get_option('awca_auth_settings')){?>
              <div class="notice notice-info top-mar manual-connect">
                <p> Please Enter your property-id / Data stream measurement id to link with website and hit submit button. </p>
              </div>
            <?php } ?>
            <div class="row manual-connect">
              <?php if(isset($awca_auth_settings['tracking_id']) && !empty($awca_auth_settings['tracking_id'])){
                 echo '<h6>'.$awca_auth_settings['tracking_id'].'</h6>';?>
                 <input placeholder="UA-XXXXX-X or G-XXXXXXXX" id="awca_auth_settings[tracking_id]" name="awca_auth_settings[tracking_id]" type="text" value="<?php if(isset($awca_auth_settings['tracking_id']) && !empty($awca_auth_settings['tracking_id'])) {echo $awca_auth_settings['tracking_id'];} ?>" class="tracking-id off">
                 <div class="input-field col m12 s12">
                   <a class="waves-effect waves-light btn modal-trigger" href="#modal1">Un-link Google Analyitcs from website.</a>
                 </div>
                 <div id="modal1" class="modal">
                   <div class="modal-content">
                     <h5>Un-Link Google Analysis from website</h5>
                     <p>Are you sure you wish to un-link Google Analysis from Website?</p>
                   </div>
                   <div class="modal-footer">
                     <a class="modal-close waves-effect waves-light btn AWCA-un-link">Un-Link Google Analytics</a>
                     <a class="modal-close waves-effect waves-green btn">Cancel</a>
                   </div>
                 </div>
               <?php }else{ ?>
              <div class="col s12 center-align">
                <div class="top-mar-30">
                  <div class="input-field col m4 offset-m4 s12">
                    <input placeholder="UA-XXXXX-X or G-XXXXXXXX" id="awca_auth_settings[tracking_id]" name="awca_auth_settings[tracking_id]" type="text" value="<?php if(isset($awca_auth_settings['tracking_id']) && !empty($awca_auth_settings['tracking_id'])) {echo $awca_auth_settings['tracking_id'];} ?>" class="tracking-id">
                    <span class="helper-text top-mar-10" data-error="wrong" data-success="right">Please put your Google Analytics Propety Id / Data stream measurement id from your GA4 here.</span>
                  </div>
                </div>
              </div>
              <?php } ?>
            </div>
          </div>
        <?php }
          if($selector && (get_option('awca_access_token'))) { ?>
        <div class="row auto-connect">
          <div class="col l8 offset-l2">
            <div class="col s12 center-align">
              <?php if(isset($awca_auth_settings['property_id']) && !empty($awca_auth_settings['property_id'])){ ?>
                <h6><?php
                $awca_show_tracking_id = explode( '|', $awca_auth_settings['property_id']);
                echo $awca_show_tracking_id[1]; ?></h6>
                <input id="awca_auth_settings[property_id]" name="awca_auth_settings[property_id]" type="text" value="<?php if(isset($awca_auth_settings['property_id']) && !empty($awca_auth_settings['property_id'])) {echo $awca_auth_settings['property_id'];} ?>" class="property-id off">
              <?php }else{ ?>
              <div class="input-field col m12 s12">
                <?php
                /*if(isset($analytics_properties) && !empty($analytics_properties)&& is_array($analytics_properties)){
                  foreach ( $analytics_properties as $account_summary ) {
          						if ( ! isset( $account_summary->kind, $account_summary->id, $account_summary->name, $account_summary->webProperties ) ) {
          							continue;
          						}
          						if ( 'analytics#accountSummary' !== $account_summary->kind ) {
          							continue;
          						}
          						foreach ( $account_summary->webProperties as $property ) {
          							if ( ! isset( $property->kind, $property->id, $property->name ) ) {
          								continue;
          							}
          							if ( 'analytics#webPropertySummary' !== $property->kind ) {
          								continue;
          							}
          							$optgroup = $account_summary->name;
          							if ( ! isset( $ga_properties[ $optgroup ] ) ) {
          								$ga_properties[ $optgroup ] = [];
          							}
          							$ga_properties[ $optgroup ][ $account_summary->id . '|' . $property->id ] = sprintf( '%s (%s)', $property->name, $property->id );
          							natcasesort( $ga_properties[ $optgroup ] );
          						}
          					}
                  }*/
                  if(isset($analytics_g4_properties) && !empty($analytics_g4_properties)&& is_array($analytics_g4_properties)){
                    foreach ( $analytics_g4_properties as $account_summary ) {
                        if(isset($account_summary->propertySummaries)){
              						foreach ( $account_summary->propertySummaries as $property ) {
                            $api = AWCA_Auth::get_instance()->get_google_management_api();
                              $web_data_streams = $api->get_web_data_streams($property->property);
                            if(isset($web_data_streams->dataStreams)&&!empty($web_data_streams->dataStreams)){
                              foreach ($web_data_streams->dataStreams as $web_data_stream){
                                $optgroup = $property->displayName;
                  							if ( ! isset( $ga_properties[ $optgroup ] ) ) {
                  								$ga_properties[ $optgroup ] = [];
                  							}
                                if(isset($web_data_stream->webStreamData->measurementId) && !empty($web_data_stream->webStreamData->measurementId))
                  							$ga_properties[ $optgroup ][ $property->property . '|' . $web_data_stream->webStreamData->measurementId ] = sprintf( '%s (%s)', $web_data_stream->displayName, $web_data_stream->webStreamData->measurementId );
                  							natcasesort( $ga_properties[ $optgroup ] );
                              }
                            }
              						}
                        }
            					}
                  }?>
                  <select id="awca_auth_settings[property_id]" name="awca_auth_settings[property_id]" class="property-id">
                    <?php
                    foreach($ga_properties as $optgroup_title=>$optgroup_options){
                    ?>
                    <optgroup label="<?php echo $optgroup_title;?>">
                      <?php
                      foreach($optgroup_options as $optgroup_option_key=>$optgroup_option_value){
                        $selected =  $awca_auth_settings['property_id'] == $optgroup_option_key ? 'selected="selected"':'';
                        echo   '<option value="'.$optgroup_option_key.'" '.$selected.'>'.$optgroup_option_value.'</option>';
                      } ?>
                    </optgroup>
                  <?php } ?>
                </select>
                <span class="helper-text top-mar-10" data-error="wrong" data-success="right">Choose Property for which you want to track data.</span>
              </div>
            <?php } ?>
            </div>
            <div id="modal1" class="modal">
              <div class="modal-content">
                <h5>Un-Link Google Analysis from website</h5>
                <p>Are you sure you wish to un-link Google Analysis from Website?</p>
              </div>
              <div class="modal-footer">
                <a class="modal-close waves-effect waves-light btn AWCA-un-link">Un-Link Google Analytics</a>
                <a class="modal-close waves-effect waves-green btn AWCA-access-revoke">Remove Access for all My Websites</a>
                <a class="modal-close waves-effect waves-green btn">Cancel</a>
              </div>
            </div>
          </div>
        </div>
      <?php } ?>
      </div>
    </div>
    <div class="row">
      <div class="col m8 offset-m2 center-align">
        <p>
          <label>
            <input type="checkbox" id="awca_auth_settings[agreement]" name="awca_auth_settings[agreement]" value="yes" <?php checked(isset($awca_auth_settings['agreement']) && $awca_auth_settings['agreement']); ?> />
            <span>I agree with <a href="https://advancedwcanalytics.com/privacy-policy/" target="_blank">privacy policy</a> and <a href="https://advancedwcanalytics.com/terms-of-service/" target="_blank">terms of service</a> of Advanced WC Analytics.</span>
          </label>
        </p>
      </div>
    </div>
		<div class="divider top-mar"></div>
  	<div class="row center-align">
  		<button class="btn waves-effect waves-light top-mar"  type="submit" name="awca_auth_submit">Submit</button>
  	</div>
  </form>
</div>
<?php
