<?php
/* controlling view of dashboard*/
if ( !defined( 'ABSPATH' ) ) {
    die;
}

/* intiating variables */
$errors = '';

/* getting dashboard settings value */
if (!get_option('awca_dash_settings')){
	$awca_dash_settings = $defaults;
  update_option('awca_dash_settings',$defaults);
}else{
	$awca_dash_settings = get_option('awca_dash_settings');
}

/* saving dashboard settings on successful submission */
if (isset($_POST['awca_dash_submit'])){
  if(!empty($_POST['awca_dash_settings'])) {
    $awca_dash_settings_save = AWCA_Settings::get_instance()->parse_awca_dash_settings($_POST['awca_dash_settings']);
    if($awca_dash_settings_save){
      if($awca_dash_settings_save['report_frame']== 'Yesterday'){
        $awca_dash_settings_save['report_to'] = date('Y-m-d', strtotime('-1 day'));
        $awca_dash_settings_save['report_from'] = date('Y-m-d', strtotime('-1 day'));
      }elseif($awca_dash_settings_save['report_frame']== 'Last 7 days'){
        $awca_dash_settings_save['report_to'] = date('Y-m-d', strtotime('-1 day'));
        $awca_dash_settings_save['report_from'] = date('Y-m-d', strtotime('-8 day'));
      }elseif($awca_dash_settings_save['report_frame']== 'Today'){
        $awca_dash_settings_save['report_to'] = date('Y-m-d', strtotime('now'));
        $awca_dash_settings_save['report_from'] = date('Y-m-d', strtotime('now'));
      }elseif($awca_dash_settings_save['report_frame']== 'Current Year'){
        $awca_dash_settings_save['report_to'] = date('Y-m-d', strtotime('now'));
        $awca_dash_settings_save['report_from'] =  date( 'Y' ) . '-01-01';
      }elseif($awca_dash_settings_save['report_frame']== 'Custom Range'){
        if (isset($awca_dash_settings_save['report_to']) && isset($awca_dash_settings_save['report_from'])){
        }else{
          $awca_dash_settings_save['report_to'] = date('Y-m-d', strtotime('-1 day'));
          $awca_dash_settings_save['report_from'] = date('Y-m-d', strtotime('-31 day'));
        }
      }else{
        $awca_dash_settings_save['report_to'] = date('Y-m-d', strtotime('-1 day'));
        $awca_dash_settings_save['report_from'] = date('Y-m-d', strtotime('-31 day'));
      }
      update_option('awca_dash_settings',$awca_dash_settings_save);
      echo "<script>
          jQuery(document).ready(function(){
             M.toast({html: 'Setting Saved!', classes: 'rounded teal', displayLength:4000});
          });
      </script>";
      $awca_dash_settings = $awca_dash_settings_save;
    } else{
      $errors .= 'Error while saving data!<br>';
      $awca_dash_settings = $awca_dash_settings_save;
    }
  }
}

/* displaying errors */
if (strlen($errors)> 0){
    echo "<script>
            jQuery(document).ready(function(){
               M.toast({html: 'Please correct following Errors:', classes: 'rounded red', displayLength:6000});
               M.toast({html: '".$errors."', classes: 'rounded red', displayLength:8000});
            });
        </script>";
}
?>

<div class="col s12 awca-options">
		<div class="col s12 top-mar">
      <div class="col m8 s12">
        <h5 class="left zero-mar">Dashboard</h5>
      </div>
    </div>
    <div class="col s12 top-mar">
        <form action="" method="POST">
          <?php if(is_array($property_views) && !empty($property_views)){
            ?>
            <div class="col m3 s12 input-field">
              <select name="awca_dash_settings[report_view]" id="report_view_id">
                <?php
                  $selected = false;
                foreach($property_views as $view) {
                  echo "<option class='test' value='".$view->id."'".( $awca_dash_settings['report_view']== $view->id ? 'selected=\"selected\"' : '' ) ." >".$view->name."</option>";
                  if($awca_dash_settings['report_view']== $view->id){
                    $selected = true;
                  }
                }
                if(!isset($awca_dash_settings['report_view']) || !($selected)){
                  $awca_dash_settings['report_view'] = $property_views[0]->id;
                }?>
              </select>
              <label>Select View</label>
            </div>
          <?php } ?>
          <div class="col m3 s12 input-field">
            <select name="awca_dash_settings[report_frame]" id="report_frame">
              <option value="Today" <?php if(isset($awca_dash_settings['report_frame'])){ echo $awca_dash_settings['report_frame']== 'Today' ? 'selected="selected"' : '';} ?> >Today</option>
              <option value="Yesterday" <?php if(isset($awca_dash_settings['report_frame'])){ echo $awca_dash_settings['report_frame']== 'Yesterday' ? 'selected="selected"' : '';} ?>>Yesterday</option>
              <option value="Last 7 days" <?php if(isset($awca_dash_settings['report_frame'])){echo $awca_dash_settings['report_frame']== 'Last 7 days' ? 'selected="selected"' : '';} ?>>Last 7 days</option>
              <option value="Last 30 days" <?php if(isset($awca_dash_settings['report_frame'])){echo $awca_dash_settings['report_frame']== 'Last 30 days' ? 'selected="selected"' : '';} ?>>Last 30 days</option>
              <option value="Current Year" <?php if(isset($awca_dash_settings['report_frame'])){echo $awca_dash_settings['report_frame']== 'Current Year' ? 'selected="selected"' : '';} ?>>Current Year</option>
              <option value="Custom Range" <?php if(isset($awca_dash_settings['report_frame'])){echo $awca_dash_settings['report_frame']== 'Custom Range' ? 'selected="selected"' : '';} ?>>Custom Range</option>
            </select>
            <label>Date Range</label>
          </div>
          <div class="col m5 s12">
            <div class="col m6 l-bord from">
  						<label>From</label>
  						<input type="text" name="awca_dash_settings[report_from]" class="datepicker" id="from"  value="<?php if(isset($awca_dash_settings['report_from'])){echo $awca_dash_settings['report_from'];} ?>">
  					</div>
  					<div class="col m6 l-bord to">
  						<label>To</label>
						<input type="text" name="awca_dash_settings[report_to]" class="datepicker" id="to" value="<?php if(isset($awca_dash_settings['report_to'])){echo $awca_dash_settings['report_to'];} ?>">
  					</div>
          </div>
          <div class="col m1 s12">
            <button class="btn waves-effect waves-light top-mar" type="submit" name="awca_dash_submit" value="submit">Go</button>
          </div>
        </form>
      </div>
    <div class="clearfix" ></div>
		<div class="divider top-mar-20" style="margin-bottom:20px"></div>
    <div class="row">
      <ul class="tabs">
      <li class="tab col m2 s4"><a id="dash-tab" href="#dash">Dashboard</a></li>
       <li class="tab col m2 s4"><a id="audience-pro-tab" href="#audience-pro">Audience<i class="material-icons awca_pro_icon info">info</i></a></li>
       <li class="tab col m2 s4"><a id="acquisition-pro-tab" href="#acquisition-pro">Acquisition<i class="material-icons awca_pro_icon info">info</i></a></li>
       <li class="tab col m2 s4"><a id="behavior-pro-tab" href="#behavior-pro">Behavior<i class="material-icons awca_pro_icon info">info</i></a></li>
       <li class="tab col m2 s4"><a id="conversion-pro-tab" href="#conversion-pro">Conversion<i class="material-icons awca_pro_icon info">info</i></a></li>
       <li class="tab col m2 s4"><a id="googleAds-pro-tab" href="#googleAds-pro">Google Ads<i class="material-icons awca_pro_icon info">info</i></a></li>
       <li class="tab col m2 s4"><a id="googleAdsense-pro-tab" href="#googleAdsense-pro">Google Adsense<i class="material-icons awca_pro_icon info">info</i></a></li>
     </ul>
    </div>
    <div id="dash" class="col s12"></div>
    <div id="audience-pro" class="col s12">
      <h5 class="center-align">Please upgrade to unlock reports and stats associated with audience.</h5>
      <div class="center-align top-mar-30">
        <a class="waves-effect waves-light btn" href="<?php echo  awca_fs()->get_upgrade_url(); ?>">Upgrade Now!</a>
      </div>
    </div>
    <div id="acquisition-pro" class="col s12">
      <h5 class="center-align">Please upgrade to unlock reports and stats associated with acquisition.</h5>
      <div class="center-align top-mar-30">
        <a class="waves-effect waves-light btn" href="<?php echo  awca_fs()->get_upgrade_url(); ?>">Upgrade Now!</a>
      </div>
    </div>
    <div id="behavior-pro" class="col s12">
      <h5 class="center-align">Please upgrade to unlock reports and stats associated with behavior of users.</h5>
      <div class="center-align top-mar-30">
        <a class="waves-effect waves-light btn" href="<?php echo  awca_fs()->get_upgrade_url(); ?>">Upgrade Now!</a>
      </div>
    </div>
    <div id="conversion-pro" class="col s12">
      <h5 class="center-align">Please upgrade to unlock reports and stats associated with conversion.</h5>
      <div class="center-align top-mar-30">
        <a class="waves-effect waves-light btn" href="<?php echo  awca_fs()->get_upgrade_url(); ?>">Upgrade Now!</a>
      </div>
    </div>
    <div id="googleAds-pro" class="col s12">
      <h5 class="center-align">Please upgrade to unlock reports and stats associated with google ads.</h5>
      <div class="center-align top-mar-30">
        <a class="waves-effect waves-light btn" href="<?php echo  awca_fs()->get_upgrade_url(); ?>">Upgrade Now!</a>
      </div>
    </div>
    <div id="googleAdsense-pro" class="col s12">
      <h5 class="center-align">Please upgrade to unlock reports and stats associated with google adsense.</h5>
      <div class="center-align top-mar-30">
        <a class="waves-effect waves-light btn" href="<?php echo  awca_fs()->get_upgrade_url(); ?>">Upgrade Now!</a>
      </div>
    </div>
  <div class="clearfix" ></div>
</div>
<?php
