<?php
/* controlling view of Event settings*/
if ( !defined( 'ABSPATH' ) ) {
    die;
}

/* intiating varibles */
$errors='';

/* getting event settings */
if (!get_option('awca_event_settings')){
	$awca_event_settings = $defaults;
}else{
	$awca_event_settings = get_option('awca_event_settings');
}

/* storing Event settings */
if (isset($_POST['awca_event_settings'])){
  $awca_event_settings_save = AWCA_Settings::get_instance()->parse_awca_bool_settings($_POST['awca_event_settings']);
  if($awca_event_settings_save){
    update_option('awca_event_settings',$awca_event_settings_save);
    echo "<script>
        jQuery(document).ready(function(){
           M.toast({html: 'Setting Saved!', classes: 'rounded teal', displayLength:4000});
        });
    </script>";
    $awca_event_settings = $awca_event_settings_save;
  } else{
    $errors .= 'Error while saving data!<br>';
    $awca_event_settings = $awca_event_settings_save;
  }
}

/* displaying errors */
if (strlen($errors)> 0){
  echo "<script>
  jQuery(document).ready(function(){
     M.toast({html: 'Please correct following Errors:', classes: 'rounded red', displayLength:6000});
     M.toast({html: '".$errors."', classes: 'rounded red', displayLength:8000});
  });
  </script>";
}

/* storing Events settings */
?>
<div class="col s12 awca-options">
	<form action="" method="POST">
		<div class="col s12 top-mar">
      <div class="col m6 s12">
        <h5 class="left zero-mar">Event Tracking</h5>
      </div>
      <div class="col m6 s12">
        <?php if ( awca_fs()->is_not_paying() && !(awca_fs()->is_trial())) { ?>
          <a class="waves-effect waves-light btn right upgrade-btn" style="margin-left:15px" href="<?php echo  awca_fs()->get_upgrade_url(); ?>">Upgrade to Pro!</a>
        <?php } ?>
        <a class="waves-effect waves-light btn right" href="https://advancedwcanalytics.com/documentation/" target="_blank"><i class="material-icons left">book</i>Documentation</a>
      </div>
		</div>
		<div class="clearfix" ></div>
		<div class="divider top-mar"></div>
    <div class="row">
      <div class="col s12">
        <?php
        foreach ($defaults as $key=>$value ){ ?>
        <div class="switch">
          <p class="col m6 s12">
            <label>
              <input type="checkbox" name="awca_event_settings[<?php echo $key;?>]"  id="awca_event_settings[<?php echo $key;?>]" value="yes" <?php checked(isset($awca_event_settings[$key]) && $awca_event_settings[$key]); ?> />
              <span class="lever"></span>
              <?php echo ucwords(str_replace("_"," ",$key)); ?>
            </label>
          </p>
        </div>
      <?php } ?>
    </div>
    <div class="clearfix"></div>
		<div class="divider top-mar"></div>
  </div>
	<div class="row center-align">
		<button class="btn waves-effect waves-light top-mar"  type="submit" value="submit" name="awca_event_settings[awca_event_submit]">Save Events Options</button>
	</div>
	</form>
  <?php if ( awca_fs()->is_not_paying() && !(awca_fs()->is_trial())) { ?>
    	<div class="col s12 awca-options upgrade-option">
    		<div class="col s12" style="margin-top:15px;vertical-align:bottom">
    			<h5 class="left margin-zero" style="margin:0px">Advance Event Tracking <span class="new badge" data-badge-caption="pro"></span></h5>
    		  <a class="waves-effect waves-light btn right upgrade-btn" style="margin-left:15px" href="<?php echo  awca_fs()->get_upgrade_url(); ?>">Upgrade to Pro!</a>
    		</div>
    		<div class="clearfix" style="clear:both"></div>
    		<div class="divider" style="margin-top:15px"></div>
    		<div class="col s6 m4">
    	    <ul class="row">
    				<li class="valign-wrapper" style="margin-bottom:15px">
    				    <i class="material-icons teal-text">check_circle</i> <!-- Icon-->
    				    <span style="margin-left:5px">User Login Errors </span>                  <!-- Text-->
    				</li>
    				<li class="valign-wrapper" style="margin-bottom:15px">
    				    <i class="material-icons teal-text">check_circle</i> <!-- Icon-->
    				    <span style="margin-left:5px">Added Product </span>                  <!-- Text-->
    				</li>
    				<li class="valign-wrapper" style="margin-bottom:15px">
    				    <i class="material-icons teal-text">check_circle</i> <!-- Icon-->
    				    <span style="margin-left:5px">Removed Product</span>                  <!-- Text-->
    				</li>
            <li class="valign-wrapper" style="margin-bottom:15px">
    				    <i class="material-icons teal-text">check_circle</i> <!-- Icon-->
    				    <span style="margin-left:5px">Changed Quantity</span>                  <!-- Text-->
    				</li>
    				<li class="valign-wrapper" style="margin-bottom:15px">
    				    <i class="material-icons teal-text">check_circle</i> <!-- Icon-->
    				    <span style="margin-left:5px">Viewed Cart</span>                  <!-- Text-->
    				</li>
    			</ul>
    		</div>
    		<div class="col s6 m4">
    	    <ul class="row">
            <li class="valign-wrapper" style="margin-bottom:15px">
    				    <i class="material-icons teal-text">check_circle</i> <!-- Icon-->
    				    <span style="margin-left:5px">Wrong Coupon Applied</span>                  <!-- Text-->
    				</li>
            <li class="valign-wrapper" style="margin-bottom:15px">
    				    <i class="material-icons teal-text">check_circle</i> <!-- Icon-->
    				    <span style="margin-left:5px">Right Coupon Applied</span>                  <!-- Text-->
    				</li>
            <li class="valign-wrapper" style="margin-bottom:15px">
    				    <i class="material-icons teal-text">check_circle</i> <!-- Icon-->
    				    <span style="margin-left:5px">Removed Coupon</span>                  <!-- Text-->
    				</li>
    				<li class="valign-wrapper" style="margin-bottom:15px">
    				    <i class="material-icons teal-text">check_circle</i> <!-- Icon-->
    				    <span style="margin-left:5px">Viewed Order</span>                  <!-- Text-->
    				</li>
    				<li class="valign-wrapper" style="margin-bottom:15px">
    				    <i class="material-icons teal-text">check_circle</i> <!-- Icon-->
    				    <span style="margin-left:5px">Changed Password</span>                  <!-- Text-->
    				</li>
    			</ul>
    		</div>
        <div class="col s6 m4">
    	    <ul class="row">
            <li class="valign-wrapper" style="margin-bottom:15px">
    				    <i class="material-icons teal-text">check_circle</i> <!-- Icon-->
    				    <span style="margin-left:5px">Lost Password</span>                  <!-- Text-->
    				</li>
            <li class="valign-wrapper" style="margin-bottom:15px">
    				    <i class="material-icons teal-text">check_circle</i> <!-- Icon-->
    				    <span style="margin-left:5px">Estimated Shipping</span>                  <!-- Text-->
    				</li>
    				<li class="valign-wrapper" style="margin-bottom:15px">
    				    <i class="material-icons teal-text">check_circle</i> <!-- Icon-->
    				    <span style="margin-left:5px">Order Cancelled </span>                  <!-- Text-->
    				</li>
            <li class="valign-wrapper" style="margin-bottom:15px">
    				    <i class="material-icons teal-text">check_circle</i> <!-- Icon-->
    				    <span style="margin-left:5px">Order Refunded</span>                  <!-- Text-->
    				</li>
    				<li class="valign-wrapper" style="margin-bottom:15px">
    				    <i class="material-icons teal-text">check_circle</i> <!-- Icon-->
    				    <span style="margin-left:5px">Log Website Error</span>                  <!-- Text-->
    				</li>
    			</ul>
    		</div>
    	</div>
  <?php } ?>
</div>
<?php
