<?php

/* controlling view of tracking settings*/
if ( !defined( 'ABSPATH' ) ) {
    die;
}
/* intiating variables */
$errors = '';
/* getting tracking settings value */

if ( !get_option( 'awca_track_settings' ) ) {
    $awca_track_settings = $defaults;
    update_option( 'awca_track_settings', $defaults );
} else {
    $awca_track_settings = get_option( 'awca_track_settings' );
}

/* saving tracking value on successful submission */
if ( isset( $_POST['awca_track_submit'] ) ) {
    
    if ( !empty($_POST['awca_track_settings']) ) {
        $awca_track_settings_save = AWCA_Settings::get_instance()->parse_awca_track_settings( $_POST['awca_track_settings'] );
        
        if ( isset( $awca_track_settings_save['gdpr_enable'] ) && $awca_track_settings_save['gdpr_enable'] ) {
            
            if ( empty($awca_track_settings_save['gdpr_title']) || empty($awca_track_settings_save['gdpr_subtitle']) ) {
                $errors .= 'Please add proper title and subtitle for GDPR notice!<br>';
                $awca_track_settings = $awca_track_settings_save;
            } else {
                
                if ( $awca_track_settings_save ) {
                    update_option( 'awca_track_settings', $awca_track_settings_save );
                    echo  "<script>\r\n              jQuery(document).ready(function(){\r\n                 M.toast({html: 'Setting Saved!', classes: 'rounded teal', displayLength:4000});\r\n              });\r\n          </script>" ;
                    $awca_track_settings = $awca_track_settings_save;
                } else {
                    $errors .= 'Error while saving data!<br>';
                    $awca_track_settings = $awca_track_settings_save;
                }
            
            }
        
        } else {
            
            if ( $awca_track_settings_save ) {
                update_option( 'awca_track_settings', $awca_track_settings_save );
                echo  "<script>\r\n            jQuery(document).ready(function(){\r\n               M.toast({html: 'Setting Saved!', classes: 'rounded teal', displayLength:4000});\r\n            });\r\n        </script>" ;
                $awca_track_settings = $awca_track_settings_save;
            } else {
                $errors .= 'Error while saving data!<br>';
                $awca_track_settings = $awca_track_settings_save;
            }
        
        }
    
    }

}
/* displaying errors */
if ( strlen( $errors ) > 0 ) {
    echo  "<script>\r\n            jQuery(document).ready(function(){\r\n               M.toast({html: 'Please correct following Errors:', classes: 'rounded red', displayLength:6000});\r\n               M.toast({html: '" . $errors . "', classes: 'rounded red', displayLength:8000});\r\n            });\r\n        </script>" ;
}
/* displaying tracking setting form */
?>
<div class="col s12 awca-options">
	<form action="" method="POST">
		<div class="col s12 top-mar">
      <div class="col m6 s12">
        <h5 class="left zero-mar">Tracking Settings</h5>
      </div>
      <div class="col m6 s12">
        <?php 

if ( awca_fs()->is_not_paying() && !awca_fs()->is_trial() ) {
    ?>
          <a class="waves-effect waves-light btn right upgrade-btn" style="margin-left:15px" href="<?php 
    echo  awca_fs()->get_upgrade_url() ;
    ?>">Upgrade to Pro!</a>
        <?php 
}

?>
        <a class="waves-effect waves-light btn right" href="https://advancedwcanalytics.com/documentation/" target="_blank"><i class="material-icons left">book</i>Documentation</a>
      </div>
		</div>
		<div class="clearfix"></div>
		<div class="divider top-mar"></div>
    <div class="row">
      <div class="col s12">
        <div class="input-field col m6 s12">
          <h6>Track User Bases</h6>
          <p>
            <label>
              <input type="checkbox" name="awca_track_settings[track_admin]"  id="awca_track_settings[track_admin]" value="yes" <?php 
checked( isset( $awca_track_settings['track_admin'] ) && $awca_track_settings['track_admin'] );
?> />
              <span>Track Admins?</span>
            </label>
            <span class="helper-text" data-error="wrong" data-success="right">Track Admin activity on Website.</span>
          </p>
          <?php 
?>
        </div>
        <div class="input-field col m6 s12">
          <h6>Other Tracking settings</h6>
          <p>
            <label>
              <input type="checkbox" name="awca_track_settings[not_track_pageviews]"  id="awca_track_settings[not_track_pageviews]" value="yes" <?php 
checked( isset( $awca_track_settings['not_track_pageviews'] ) && $awca_track_settings['not_track_pageviews'] );
?> />
              <span>Do not Track Pageviews</span>
            </label>
            <span class="helper-text" data-error="wrong" data-success="right">Stop tracking basic pageviews for website.</span>
          </p>
          <?php 
?>
          <p>
            <label>
              <input type="checkbox" name="awca_track_settings[anonymize_ip]"  id="awca_track_settings[anonymize_ip]" value="yes" <?php 
checked( isset( $awca_track_settings['anonymize_ip'] ) && $awca_track_settings['anonymize_ip'] );
?> />
              <span>Anonymize IP addresses</span>
            </label>
            <span class="helper-text" data-error="wrong" data-success="right">Anonymizes the ip address of website users.</span>
          </p>
          <p>
            <label>
              <input type="checkbox" name="awca_track_settings[disable_on_hold_conversion]"  id="awca_track_settings[disable_on_hold_conversion]" value="yes" <?php 
checked( isset( $awca_track_settings['disable_on_hold_conversion'] ) && $awca_track_settings['disable_on_hold_conversion'] );
?> />
              <span>Disable On Hold Transctions as Conversions</span>
            </label>
            <span class="helper-text" data-error="wrong" data-success="right">It will not consider on-hold transcations as conversions.</span>
          </p>
        </div>
        <div class="input-field col m6 s12">

        </div>
      </div>
    </div>
    <div class="row">
      <div class="col s12">
        <div class="input-field col m6 s12">
          <h6>Frontend GDPR Notice</h6>
          <p>
            <label>
              <input type="checkbox" class="check_gdpr" name="awca_track_settings[gdpr_enable]"  id="awca_track_settings[gdpr_enable]" value="yes" <?php 
checked( isset( $awca_track_settings['gdpr_enable'] ) && $awca_track_settings['gdpr_enable'] );
?> />
              <span>Enable GDPR Notice?</span>
            </label>
            <span class="helper-text" data-error="wrong" data-success="right">Enable GDPR Analytics Notice for Website users.</span>
          </p>
          <p class="awca-gdpr">
            <input placeholder="GDPR Notice Title" type="text" name="awca_track_settings[gdpr_title]"  id="awca_track_settings[gdpr_title]" value="<?php 
if ( isset( $awca_track_settings['gdpr_title'] ) && !empty($awca_track_settings['gdpr_title']) ) {
    echo  $awca_track_settings['gdpr_title'] ;
}
?>"  />
            <span class="helper-text" data-error="wrong" data-success="right">GDPR Notice Title</span>
          </p>
          <p class="awca-gdpr">
            <input placeholder="GDPR Notice Subtitle" type="text" name="awca_track_settings[gdpr_subtitle]"  id="awca_track_settings[gdpr_subtitle]" value="<?php 
if ( isset( $awca_track_settings['gdpr_subtitle'] ) && !empty($awca_track_settings['gdpr_subtitle']) ) {
    echo  $awca_track_settings['gdpr_subtitle'] ;
}
?>"  />
            <span class="helper-text" data-error="wrong" data-success="right">GDPR Notice Subtitle</span>
          </p>
          <div class="tb-pad-10"></div>
        </div>
        <div class="input-field col m6 s12 awca-gdpr">
          <h6>Other GDPR Notice Display Settings</h6>
          <p>
            <label>
              <input type="checkbox" name="awca_track_settings[gdpr_pos_right]"  id="awca_track_settings[gdpr_pos_right]" value="yes" <?php 
checked( isset( $awca_track_settings['gdpr_pos_right'] ) && $awca_track_settings['gdpr_pos_right'] );
?> />
              <span>Put Notice on right corner</span>
            </label>
            <span class="helper-text" data-error="wrong" data-success="right">Set Notice position on right corner otherwise left corner as default.</span>
          </p>
          <p>
            <input placeholder="GDPR Opt-in Button Title" type="text" name="awca_track_settings[gdpr_opt_in_name]"  id="awca_track_settings[gdpr_opt_in_name]" value="<?php 
if ( isset( $awca_track_settings['gdpr_opt_in_name'] ) && !empty($awca_track_settings['gdpr_opt_in_name']) ) {
    echo  $awca_track_settings['gdpr_opt_in_name'] ;
}
?>"  />
            <span class="helper-text" data-error="wrong" data-success="right">Change Opt-in Button Text</span>
          </p>
          <p>
            <input placeholder="GDPR Opt-out Button Title" type="text" name="awca_track_settings[gdpr_opt_out_name]"  id="awca_track_settings[gdpr_opt_out_name]" value="<?php 
if ( isset( $awca_track_settings['gdpr_opt_out_name'] ) && !empty($awca_track_settings['gdpr_opt_out_name']) ) {
    echo  $awca_track_settings['gdpr_opt_out_name'] ;
}
?>"  />
            <span class="helper-text" data-error="wrong" data-success="right">Change Opt-out Button Text</span>
          </p>
          <p>
            <input placeholder="GDPR Related Image/Site Fevicon URL" type="url" name="awca_track_settings[gdpr_image_url]"  id="awca_track_settings[gdpr_image_url]" value="<?php 
if ( isset( $awca_track_settings['gdpr_image_url'] ) && !empty($awca_track_settings['gdpr_image_url']) ) {
    echo  $awca_track_settings['gdpr_image_url'] ;
}
?>"  />
            <span class="helper-text" data-error="wrong" data-success="right">Put your fevicon url so it can displayed with GDPR notice</span>
          </p>
          <div class="tb-pad-10"></div>
        </div>
      </div>
    </div>
		<div class="divider top-mar"></div>
  	<div class="row center-align">
  		<button class="btn waves-effect waves-light top-mar-30"  type="submit" name="awca_track_submit" value="submit">Save Tracking Options</button>
  	</div>
	</form>
  <?php 

if ( awca_fs()->is_not_paying() && !awca_fs()->is_trial() ) {
    ?>
    	<div class="col s12 upgrade-option">
    		<div class="col s12" style="margin-top:15px;vertical-align:bottom">
    			<h5 class="left margin-zero" style="margin:0px">Advance Tracking Features <span class="new badge" data-badge-caption="pro"></span></h5>
    			<a class="waves-effect waves-light btn right upgrade-btn" style="margin-left:15px" href="<?php 
    echo  awca_fs()->get_upgrade_url() ;
    ?>">Upgrade to Pro!</a>
    		</div>
    		<div class="clearfix" style="clear:both"></div>
    		<div class="divider" style="margin-top:15px"></div>
    		<div id="test-2" class="col s6">
    	    <ul class="row">
    				<li class="valign-wrapper" style="margin-bottom:15px">
    				    <i class="material-icons teal-text">check_circle</i> <!-- Icon-->
    				    <span style="margin-left:5px">User ID Tracking</span>                  <!-- Text-->
    				</li>
    				<li class="valign-wrapper" style="margin-bottom:15px">
    				    <i class="material-icons teal-text">check_circle</i> <!-- Icon-->
    				    <span style="margin-left:5px">Product Impressions Tracking on Archieve Pages</span>                  <!-- Text-->
    				</li>
    			</ul>
    		</div>
    		<div class="col s6">
    	    <ul class="row">
            <li class="valign-wrapper" style="margin-bottom:15px">
    				    <i class="material-icons teal-text">check_circle</i> <!-- Icon-->
    				    <span style="margin-left:5px">Product Impressions Tracking on Single Product Pages</span>                  <!-- Text-->
    				</li>
    				<li class="valign-wrapper" style="margin-bottom:15px">
    				    <i class="material-icons teal-text">check_circle</i> <!-- Icon-->
    				    <span style="margin-left:5px">Enhanced Link Attribution</span>                  <!-- Text-->
    				</li>
    			</ul>
    		</div>
    	</div>
  <?php 
}

?>
</div>
